require conv_main;

$output_file_handle;

$DEFAULT_COV = 1;     # exponential
$DEFAULT_PHASE = 0;   # stochastic
$DEFAULT_FANIN = 0;
$DEFAULT_FANOUT = 0;
$DEFAULT_THINKTIME =0;
$DEFAULT_SERVICETIME = 0;
$DEFAULT_MAXSERVICE = 0;

$PREAMBLE_BLOCK_ID = 0;
$PROCESSOR_BLOCK_ID = 1;
$TASK_BLOCK_ID = 2;
$ENTRY_BLOCK_ID = 3;
$ACTIVITY_BLOCK_ID = 3;
$ACTIVITY_CALL_BLOCK_ID = 4;
$ACTIVITY_CONNECTION_BLOCK_ID = 3;
$CALL_BLOCK_ID = 4;
$REQ_FORWARD_ID = 4;
$SPEX_REPORT_ID = 10;
$SPEX_CONVERGENCE_ID = 11;
$ENTRY_PRESIDENCE = 0;
$ACTIVITY_PRESIDENCE = 1;
$ACTIVITY_CALL_PRESIDENCE = 1;
$ACTIVITY_CONNECTION_PRESIDENCE = 2;

$blank_line = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
$blank_line_1 = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t";  # blank line -1 \t

# This is the position in the file where we will have to write the final cur_id value
# so the spreadsheet can operate correctly after the file has been imported.

$curid_file_pos = 0;

$cur_block_id = 0;

sub generate_LQN_spreadsheet
{
# $_[0]: The name of the file that which will contain the output of the parser.

   if (open (OUTPUT_FILE, ">".$_[0].".txt") != 1)
   {
      die "ERROR - cannot open file \"$_[0]\" for writing.\n";
   }

   $output_file_handle = *OUTPUT_FILE;

   &generate_spreadsheet_init_block;

# Increase cur_block_id so that the SPEX init block and first processor have a different ID.
# Not totally sure why that never happened in the first place.
   $cur_block_id += 2;

   &generate_spreadsheet;

# For LQN mode, we need to add a blank line that has a tag value of SPEX_REPORT_ID

   print $output_file_handle "$blank_line#\t$SPEX_REPORT_ID\t0\n";
   &add_id_count_on_top;
   close($output_file_handle);
}

sub generate_SPEX_spreadsheet
{
   if (open (OUT_LQN, ">".$_[0].".xtxt") != 1)
   {
      die "ERROR - cannot open file \"$output_file\" for writing.\n";
   }

   $output_file_handle = *OUT_LQN;

   &generate_spreadsheet_init_block;

# Increase cur_block_id so that the SPEX init block and first processor have a different ID.
# Not totally sure why that never happened in the first place.

   $cur_block_id += 2;

   &generate_spreadsheet;
   &generate_SPEX_report_block;

# Decided to always generate a convergence block even if not defined in the model
#   if ($defined_SPEX_convergence == 1)
#   {
      &generate_SPEX_convergence_block;
#   }

   &add_id_count_on_top;
   close($output_file_handle);
}

sub generate_spreadsheet
{
   my $cur_processor;
   my $cur_task;
   my $cur_entry;
   my @processors=();
   my @tasks=();
   my @entries=();

   @processors = keys %processor_list;
   @tasks = keys %task_list1;

   foreach $cur_processor (@processors)
   {
      &generate_processor_block($cur_processor);
      
      foreach $cur_task (@tasks)
      {
         if (index($task_list2{$cur_task}, $cur_processor) != -1)
         {
            &generate_task_block($cur_task);

            @temp_entry_list = split (" ", $task_list1{$cur_task});
            $num_temp_entry_list = @temp_entry_list;
            @entry_list_cur_task = @temp_entry_list[1..$num_temp_entry_list-1];

            foreach $cur_entry (@entry_list_cur_task)
            {
            # NOTE: We don't want to generate a entry block when it's really an activity
	       if (!defined $entry_list_activities{$cur_entry})
               {
		  &generate_entry_block($cur_entry);

		  if (defined $call_list_forwarding{$cur_entry})
		  {
		     &generate_call_forwarding_block($cur_entry);
		  }

		  if (defined $call_list_number{$cur_entry})
		  {
		     &generate_call_block($cur_entry);
		  }
	       }
            }

            @activity_list_cur_task = split(":", $task_activity_lookup_list{$cur_task});

            foreach $cur_activity (@activity_list_cur_task)
            {
       	       &generate_activity_block($cur_activity);

               if (defined $activity_calls{$cur_activity})
               {
  	          &generate_activity_call_block($cur_activity);
               }
            }

            &generate_activity_connection_block($cur_task);
         }
      }
   }
}

sub generate_spreadsheet_init_block
{
   $cur_block_id = 0;  # if you don't initialize this variable here, who knows what it will become...
   if ($op_mode eq "SPEX")
   {
      print $output_file_handle "MODE:\t\t\tSPEX\t\t\t\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\t\t";
   }
   else
   {
      print $output_file_handle "MODE:\t\t\tLQN\t\t\t\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\t\t";
   }

# Now we want to remember this place in the file, because we will go back an write to this area again
# updating the $cur_block_id variable for the spreadsheet.

   $curid_file_pos = tell($output_file_handle);

# We will leave 6 tabs here, which caps the cur_id at a value of 999999

   print $output_file_handle "\t\t\t\t\t\t\n";

   print $output_file_handle "FILE:\t\t\tnone\t\t\t# spreadlaunch script needs this field (When using Star Office 5.0)\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n";

   if ($op_mode eq "SPEX")
   {
      print $output_file_handle "SPEX_PARAMETERS:\t\t\t-NONE-\t\t\t# parameters that go into SPEX when using spreadlaunch script (When using Star Office 5.0)\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n";
   }
   else
   {
      print $output_file_handle "$blank_line#\t0\t$cur_block_id\n";
   }

   if ($solver eq "")
   {
      print $output_file_handle "SOLVER:\t\t\tlqns\t\t\t# lqns, parasrvn... you can include full path also\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n";
   }
   else
   {
      print $output_file_handle "SOLVER:\t\t\t$solver\t\t\t# lqns, parasrvn... you can include full path also\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n";
   }

   if ($solver_parameters eq "")
   {
      print $output_file_handle "SOLVER_PARAMETERS:\t\t\t-none-\t\t\t# enter switches as you would on the command line for a particular solver\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n$blank_line#\t0\t$cur_block_id\n";
   }
   else
   {
      print $output_file_handle "SOLVER_PARAMETERS:\t\t\t$solver_parameters\t\t\t# enter switches as you would on the command line for a particular solver\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n$blank_line#\t0\t$cur_block_id\n";
   }

   print $output_file_handle "Model_Comments:$blank_line#\t0\t$cur_block_id\n";

   @model_comment_lines = split("\n", $model_comments);

   if (@model_comment_lines < 1)
   {
      print $output_file_handle "# Model Comments go here, and end at keyword Pragma.  You can insert more lines if you want. $blank_line#\t0\t$cur_block_id\n";
   }
   else
   {
      foreach my $cur_block_line (@model_comment_lines)
      {
	 print $output_file_handle "$cur_block_line$blank_line#\t0\t$cur_block_id\n";
      }
   }

   print $output_file_handle "$blank_line#\t0\t$cur_block_id\nPragma:$blank_line#\t0\t$cur_block_id\n";

   @pragmas = split("\n", $model_pragmas);

   if (@pragmas < 1)
   {
      print $output_file_handle "# Enter pragmas one per line, until keyword Convergence_Limit.  Insert as many as you need. $blank_line#\t0\t$cur_block_id\n";
   }

   foreach $cur_pragma (@pragmas)
   {
      print $output_file_handle "pragma $cur_pragma$blank_line#\t0\t$cur_block_id\n";
   }
   print $output_file_handle "$blank_line#\t0\t$cur_block_id\n";

   print $output_file_handle "Convergence_Limit:\t\t\t$convergence_limit\t\t\t\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n";
   print $output_file_handle "Iteration_Limit:\t\t\t$iteration_limit\t\t\t\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n";
   print $output_file_handle "Print_Interval:\t\t\t$print_interval\t\t\t\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n";
   print $output_file_handle "Underrelaxation_Coefficient:\t\t\t$underrelaxation_coeff\t\t\t\t\t\t\t\t\t\t\t\t#\t0\t$cur_block_id\n$blank_line#\t0\t$cur_block_id\n";

   if ($op_mode eq "SPEX")
   {
      $cur_block_id++;
      print $output_file_handle "$blank_line#\t0\t$cur_block_id\nSPEX_INIT_START$blank_line#\t0\t$cur_block_id\n$blank_line#\t0\t$cur_block_id\n";
      @spex_init_lines = split("\n", $SPEX_init_block);

      foreach my $cur_block_line (@spex_init_lines)
      {
         print $output_file_handle "$cur_block_line$blank_line#\t0\t$cur_block_id\n";
      }

      print $output_file_handle "$blank_line#\t0\t$cur_block_id\nSPEX_INIT_END$blank_line#\t0\t$cur_block_id\n$blank_line#\t0\t$cur_block_id\n";
   }
}

sub generate_SPEX_report_block
{
   $cur_block_id++;
   print $output_file_handle "$blank_line#\t$SPEX_REPORT_ID\t$cur_block_id\nSPEX_REPORT_START$blank_line#\t$SPEX_REPORT_ID\t$cur_block_id\n";

   @spex_report_lines = split("\n", $SPEX_report_block);

   foreach my $cur_block_line (@spex_report_lines)
   {
      print $output_file_handle "$cur_block_line$blank_line#\t$SPEX_REPORT_ID\t$cur_block_id\n";
   }

   print $output_file_handle "$blank_line#\t$SPEX_REPORT_ID\t$cur_block_id\nSPEX_REPORT_END$blank_line#\t$SPEX_REPORT_ID\t$cur_block_id\n$blank_line#\t$SPEX_REPORT_ID\t$cur_block_id\n";
}

sub generate_SPEX_convergence_block
{
   $cur_block_id++;
   print $output_file_handle "$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\nSPEX_CONVERGENCE_START$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\n";

   if ($defined_SPEX_convergence == 1)
   {
      @spex_conv_lines = split("\n", $SPEX_convergence_block);

      foreach my $cur_block_line (@spex_conv_lines)
      {
	 print $output_file_handle "$cur_block_line$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\n";
      }
   }
   else
   {
      print $output_file_handle "$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\n#SPEX convergence block$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\n$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\n";
   }

   print $output_file_handle "SPEX_CONVERGENCE_END$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\n$blank_line#\t$SPEX_CONVERGENCE_ID\t$cur_block_id\n";
}


sub generate_processor_block
{
# $_[0] is the name of the processor

   my @processor_values = ();

   $cur_block_id++;

   if ($op_mode eq "SPEX")
   { 
      @SPEX_info = split(";", $processor_list{$_[0]});
      @processor_values = split(" ", @SPEX_info[0]);
   }
   else
   {      
      @processor_values = split(" ", $processor_list{$_[0]});
   }

   print $output_file_handle "Processor:\t\t\tName\tDiscipline\tMultiplicity\tQuantum\tReplicas\tProc_Rate";

   if ($op_mode eq "SPEX")
   {
       print $output_file_handle "\t\t# SPEX Observation keys go below\t\t\t\t\t#\t$PROCESSOR_BLOCK_ID\t$cur_block_id\n";
   }
   else
   {
      print $output_file_handle "\t\t\t\t\t\t\t#\t$PROCESSOR_BLOCK_ID\t$cur_block_id\n";
   }

   print $output_file_handle "\t\t\t$_[0]\t@processor_values[0]\t@processor_values[1]\t@processor_values[2]\t@processor_values[3]\t@processor_values[4]";

   if ($op_mode eq "SPEX")
   {
       print $output_file_handle "\t\t@SPEX_info[1]\t\t\t\t\t";
   }
   else
   {
 # This is to balance out the \t when there are no SPEX observations
      print $output_file_handle "\t\t\t\t\t\t\t";
   }

   print $output_file_handle "#\t$PROCESSOR_BLOCK_ID\t$cur_block_id\n$blank_line#\t$PROCESSOR_BLOCK_ID\t$cur_block_id\n";
}


sub generate_task_block
{
# $_[0] is the name of the current task we are generating

   $cur_block_id++;

   if ($op_mode eq "SPEX")
   { 
      @SPEX_info = split(";", $task_list2{$_[0]});
      @task_values2 = split(" ", @SPEX_info[0]);
   }
   else
   {      
      @task_values2 = split(" ", $task_list2{$_[0]});
   }

   @task_values1 = split(" ", $task_list1{$_[0]});

   print $output_file_handle "\tTask:\t\tName\tDiscipline\tMultiplicity\tThink_Time\tReplicas\tPriority";

   if ($op_mode eq "SPEX")
   {
       print $output_file_handle "\t\t# SPEX Observation keys go below\t\t\t\t\t#\t$TASK_BLOCK_ID\t$cur_block_id\n";
   }
   else
   {
      print $output_file_handle "\t\t\t\t\t\t\t#\t$TASK_BLOCK_ID\t$cur_block_id\n";
   }

   print $output_file_handle "\t\t\t$_[0]\t@task_values1[0]\t@task_values2[3]\t@task_values2[2]\t@task_values2[4]\t@task_values2[1]";

   if ($op_mode eq "SPEX")
   {
       print $output_file_handle "\t\t@SPEX_info[1]";
   }
   else
   {
 # This is to balance out the \t when there are no SPEX observations
      print $output_file_handle "\t\t";
   }

   print $output_file_handle "\t\t\t\t\t#\t$TASK_BLOCK_ID\t$cur_block_id\n$blank_line#\t$TASK_BLOCK_ID\t$cur_block_id\n";
}


sub generate_entry_block
{
# $_[0] is the name of the current entry we are generating

   my $entry_priority;
   my $entry_arriv_rate;

   $cur_block_id++;

   print $output_file_handle "\t\tEntry:\tName\tPriority\tArrival_Rate";

   if ($op_mode eq "SPEX")
   {
       print $output_file_handle "\t\t\t\t\t# SPEX Observation keys go below\t\t\t\t\t#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n";
   }
   else
   {
      print $output_file_handle "\t\t\t\t\t\t\t\t\t\t#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n";
   }

   if (defined $entry_list_arriv_rate{$_[0]})
   {
      $entry_arriv_rate = $entry_list_arriv_rate{$_[0]};
   }
   else
   {
      $entry_arriv_rate = 0;
   }

   if (defined $entry_list_priority{$_[0]})
   {
      $entry_priority = $entry_list_priority{$_[0]};
   }
   else
   {
      $entry_priority = 0;
   }

   print $output_file_handle "\t\t\t$_[0]\t$entry_priority\t$entry_arriv_rate";

   if ($op_mode eq "SPEX")
   {
      @SPEX_info = split(";", $entry_list_service{$_[0]});
      print $output_file_handle "\t\t@SPEX_info[1]\t\t\t";

      @serv_values = split(" ", @SPEX_info[0]);
      $num_phases = @serv_values-2;
   }
   else
   {
 # This is to balance out the \t when there are no SPEX observations
      print $output_file_handle "\t\t\t\t\t";
   }

   print $output_file_handle "\t\t\t\t\t#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n$blank_line#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n";

   print $output_file_handle "\t\t\t\tService_Time\tCOV\tPhase_Type\tThink_Time\tMax_Service\t\t\t\t\t\t\t#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n";

# find out the number of phases in this particular entry...

###### Why do I have this check for LQN below?????

#   if ($op_mode eq "LQN")
#   {
      if (defined $entry_list_service{$_[0]})
      {
         @serv_values = split(" ", $entry_list_service{$_[0]});
         $num_phases = @serv_values-2;
      }
#   }
   
   if (defined $entry_list_phasetype{$_[0]})
   {
      @phasetype_values = split(" ", $entry_list_phasetype{$_[0]});
      $num_phases = @phasetype_values-2;
   }
   
   if (defined $entry_list_COV{$_[0]})
   {
      @COV_values = split(" ", $entry_list_COV{$_[0]});
      $num_phases = @COV_values-2;
   }
   
   if (defined $entry_list_thinktime{$_[0]})
   {
      @thinktime_values = split(" ", $entry_list_thinktime{$_[0]});
      $num_phases = @thinktime_values-2;
   }

   if (defined $entry_list_maxservice{$_[0]})
   {
       @maxserv_values = split(" ", $entry_list_maxservice{$_[0]});
       $num_phases = @maxserv_values-2;
   }

   for ($x=1;$x<=$num_phases;$x++)
   {
      print $output_file_handle "\t\t\tPhase_$x\t";

      if (defined $entry_list_service{$_[0]})
      {
         print $output_file_handle "@serv_values[$x+1]\t";
      }
      else
      { # default service time value
         print $output_file_handle "0\t";
      }

      if (defined $entry_list_COV{$_[0]})
      {
         print $output_file_handle "@COV_values[$x+1]\t";
      }
      else
      { # default COV value
         print $output_file_handle "$DEFAULT_COV\t";
      }

      if (defined $entry_list_phasetype{$_[0]})
      {
         if (@phasetype_values[$x+1] =~ /^\$/)
         {
            print $output_file_handle "@phasetype_values[$x+1]\t";
         }
         elsif (@phasetype_values[$x+1] == 0)
         {
            print $output_file_handle "S\t";
	 }
         else
         {
            print $output_file_handle "D\t";
         }
#         print $output_file_handle "@phasetype_values[$x+1]\t";
      }
      else
      { # default phasetype value
         print $output_file_handle "S\t";
#         print $output_file_handle "$DEFAULT_PHASE\t";
      }
   
      if (defined $entry_list_thinktime{$_[0]})
      {
         print $output_file_handle "@thinktime_values[$x+1]\t";
      }
      else
      {
         print $output_file_handle "$DEFAULT_THINKTIME\t";
      }

      if (defined $entry_list_maxservice{$_[0]})
      {
         print $output_file_handle "@maxserv_values[$x+1]\t\t\t\t\t\t\t#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n";
      }
      else
      {
         print $output_file_handle "$DEFAULT_MAXSERVICE\t\t\t\t\t\t\t#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n";
      }
   }

   print $output_file_handle "$blank_line#\t$ENTRY_BLOCK_ID\t$cur_block_id\t$ENTRY_PRESIDENCE\n";
}


sub generate_call_block
{
# passing the name of the current entry into this function which is $_[0]

   my $cur_entry = $_[0];
   my $num_phases;

   @call_parts = keys %{$call_list_number{$cur_entry}};

   foreach $cur_call_part (@call_parts)
   {

      $cur_block_id++;

# NOTE: here we have to split the LQN entry information line in half to insert the entry name.

      if ($op_mode eq "SPEX")
      {
         @SPEX_info = split(";", $call_list_number{$cur_entry}{$cur_call_part});
         @call_values = split(" ", @SPEX_info[0]);
      }
      else
      {
         @call_values = split(" ", $call_list_number{$cur_entry}{$cur_call_part});
      }

      $num_phases = @call_values - 3;

      print $output_file_handle "\t\t\tCalls:\t\tTo_Entry_Name\tSync/Async";

      if ($op_mode eq "SPEX")
      { 
         print $output_file_handle "\t\t\t\t# SPEX Observation keys go below\t\t\t\t\t#\t$CALL_BLOCK_ID\t$cur_block_id\n";
      }
      else
      {
         print $output_file_handle "\t\t\t\t\t\t\t\t\t#\t$CALL_BLOCK_ID\t$cur_block_id\n";
      }

      print $output_file_handle "\t\t\t\t\t$cur_call_part\t";

      if (@call_values[0] eq "z")
      {
         print $output_file_handle "A";
      }
      elsif (@call_values[0] eq "y")
      {
         print $output_file_handle "S";
      }
      else
      {
         print "ERROR in call generation, the first letter in $cur_call_part is not supported at this time.\n";
      }

      if ($op_mode eq "SPEX")
      { 
            print $output_file_handle "\t\t\t\t$SPEX_info[1]";
      }
      else
      {
 # This is to balance out the \t when there are no SPEX observations
         print $output_file_handle "\t\t\t\t";
      }

      print $output_file_handle "\t\t\t\t\t#\t$CALL_BLOCK_ID\t$cur_block_id\n$blank_line#\t$CALL_BLOCK_ID\t$cur_block_id\n";

      print $output_file_handle "\t\t\t\t\tNumber_of_Calls\tFan_In\tFan_Out\t\t\t\t\t\t\t\t#\t$CALL_BLOCK_ID\t$cur_block_id\n";

      if (defined $call_list_fanin{$cur_entry}{$cur_call_part})
      {
         @fanin_values = split(" ", $call_list_fanin{$cur_entry}{$cur_call_part});
         $num_fanin_values = @fanin_values;

# Need to fill this information in, to keep the spreadsheet consistent.  Fanout/Fanin only accepts 1 parameter, not a vector.

         if ($num_fanin_values -3 < $num_phases)
         {
	     for ($x=$num_fanin_values-3; $x<$num_phases; $x++)
             {
    	        @fanin_values[$x+3] = $DEFAULT_FANIN;
             }
         }
      }
      else
      {
         for ($x=0;$x<$num_phases+3;$x++)
         {
            if ($x<3)
            {
	       @fanin_values[$x] = -1;
            }
            else
            {
               @fanin_values[$x]=$DEFAULT_FANIN;
            }
         }
      }

      @fanout_values = split(" ", "-1 -1 -1 $DEFAULT_FANOUT, $DEFAULT_FANOUT, $DEFAULT_FANOUT");

      if (defined $call_list_fanout{$cur_entry}{$cur_call_part})
      {
         @fanout_values = split(" ", $call_list_fanout{$cur_entry}{$cur_call_part});
         $num_fanout_values = @fanout_values;

# Need to fill this information in, to keep the spreadsheet consistent.  Fanout/Fanin only accepts 1 parameter, not a vector.

         if ($num_fanout_values -3 < $num_phases)
         {
	     for ($x=$num_fanout_values-3; $x<$num_phases; $x++)
             {
    	        @fanout_values[$x+3] = $DEFAULT_FANOUT;
             }
         }
      }
      else
      {
         for ($x=0;$x<$num_phases+3;$x++)
         {
            if ($x<3)
            {
	       @fanout_values[$x]=-1;
            }
            else
            {
               @fanout_values[$x]=$DEFAULT_FANOUT;
            }
         }
      }

      for ($x=1;$x<=$num_phases;$x++)
      {
         print $output_file_handle "\t\t\t\tPhase_$x\t@call_values[$x+2]\t@fanin_values[$x+2]\t@fanout_values[$x+2]\t\t\t\t\t\t\t\t#\t$CALL_BLOCK_ID\t$cur_block_id\n";
      }
      print $output_file_handle "$blank_line#\t$CALL_BLOCK_ID\t$cur_block_id\n";
   }
}


sub generate_call_forwarding_block
{
# passing the name of the current entry into this function which is $_[0]

   my $cur_entry = $_[0];

   $cur_block_id++;

   @call_parts = keys %{$call_list_forwarding{$cur_entry}};

   foreach $cur_call_part (@call_parts)
   {

# NOTE: here we have to split the LQN entry information line in half to insert the entry name.

      @call_values = split(" ", $call_list_number{$cur_entry}{$cur_call_part});

      print $output_file_handle "\t\t\tRequest_Forwarding:\tTo_Entry_Name\t\tProb_Forwarding";
      print $output_file_handle "\t\t\t\t\t\t\t\t\t#\t$REQ_FORWARD_ID\t$cur_block_id\n";


      print $output_file_handle "\t\t\t\t$cur_call_part\t\t@call_values[3]";
      print $output_file_handle "\t\t\t\t\t\t\t\t\t#\t$REQ_FORWARD_ID\t$cur_block_id\n";
      print $output_file_handle "$blank_line#\t$REQ_FORWARD_ID\t$cur_block_id\n";
    }
}


sub generate_activity_block
{
# $_[0] is the name of the activity we want to generate a block for.

   my $activity = $_[0];
   $cur_block_id++;

   print $output_file_handle "\t\tActivity:\tName\tService_Time\tThink_Time\tCOV\tPhase_Type\tBind_To_Entry";
   print $output_file_handle "\t\t\t\t\t\t\t#\t$ACTIVITY_BLOCK_ID\t$cur_block_id\t$ACTIVITY_PRESIDENCE\n";
   
   print $output_file_handle "\t\t\t$activity\t";
  
   if (defined $activity_list_service{$activity})
   {
      print $output_file_handle "$activity_list_service{$activity}\t";
   }
   else
   {
      print $output_file_handle "$DEFAULT_SERVICETIME\t";
   }

   if (defined $activity_list_thinktime{$activity})
   {
      print $output_file_handle "$activity_list_thinktime{$activity}\t";
   }
   else
   {
      print $output_file_handle "$DEFAULT_THINKTIME\t";
   }

   if (defined $activity_list_COV{$activity})
   {
      print $output_file_handle "$activity_list_COV{$activity}\t";
   }
   else
   {
      print $output_file_handle "$DEFAULT_COV\t";
   }

   if (defined $activity_list_phasetype{$activity})
   {
      if ($activity_list_phasetype{$activity} == 0)
      {
         print $output_file_handle "S\t";
      }
      else
      {
         print $output_file_handle "D\t";
      }
   }
   else
   {
#      print $output_file_handle "$DEFAULT_PHASE\t";
      print $output_file_handle "S\t";
   }

   if (defined $activity_list_entry{$activity})
   {
      print $output_file_handle "$activity_list_entry{$activity}";
   }
   else
   {
      print $output_file_handle "N/A";
   }

   print $output_file_handle "\t\t\t\t\t\t\t#\t$ACTIVITY_BLOCK_ID\t$cur_block_id\t$ACTIVITY_PRESIDENCE\n";
   print $output_file_handle "$blank_line#\t$ACTIVITY_BLOCK_ID\t$cur_block_id\t$ACTIVITY_PRESIDENCE\n";
}


sub generate_activity_call_block
{
# passing the name of the current activity into this function which is $_[0]

   my $cur_activity = $_[0];

   @call_parts = keys %{$activity_calls{$cur_activity}};

   foreach $cur_call_part (@call_parts)
   {
      $cur_block_id++;
      @call_values = split(" ", $activity_calls{$cur_activity}{$cur_call_part});

      print $output_file_handle "\t\t\tCalls:\tTo_Entry_Name\tSync/Async\tNumber_Of_Calls";
      print $output_file_handle "\t\t\t\t\t\t\t\t\t#\t$ACTIVITY_CALL_BLOCK_ID\t$cur_block_id\t$ACTIVITY_CALL_PRESIDENCE\n";
      print $output_file_handle "\t\t\t\t@call_values[2]\t";

      if (@call_values[0] eq "y")
      {
         print $output_file_handle "S\t";
      }
      elsif (@call_values[0] eq "z")
      {
         print $output_file_handle "A\t";
      }
      else
      {
         die "INTERNAL ERROR (current line is $cur_line) - For some reason we have an unexpected field type \"$call_values[0]\" in making a call.\n";
      }

      print $output_file_handle "@call_values[3]";
      print $output_file_handle "\t\t\t\t\t\t\t\t\t#\t$ACTIVITY_CALL_BLOCK_ID\t$cur_block_id\t$ACTIVITY_CALL_PRESIDENCE\n";
      print $output_file_handle "$blank_line#\t$ACTIVITY_CALL_BLOCK_ID\t$cur_block_id\t$ACTIVITY_CALL_PRESIDENCE\n";
   }
}

sub generate_activity_connection_block
{
# $_[0] is the current task the activity connections are in

   my $task = $_[0];
   @act_connections = split("\n", $activity_connections{$task});

   foreach $cur_act_connection (@act_connections)
   {
      $cur_block_id++;

      print $output_file_handle "\t\tActivity_Connection:\t\t$cur_act_connection";
      print $output_file_handle "\t\t\t\t\t\t\t\t\t\t\t#\t$ACTIVITY_CONNECTION_BLOCK_ID\t$cur_block_id\t$ACTIVITY_CONNECTION_PRESIDENCE\n";
      print $output_file_handle "$blank_line#\t$ACTIVITY_CONNECTION_BLOCK_ID\t$cur_block_id\t$ACTIVITY_CONNECTION_PRESIDENCE\n";
   }
}

sub add_id_count_on_top
{
   seek($output_file_handle, $curid_file_pos, 0);
   print $output_file_handle "$cur_block_id";
}

sub all_default_values
{
# This routine checks a given LQN formatted line to see if there are any default values present which may not need printing.

   my @parts = split(" ", $_[0]);
   my $num_parts = @parts;
   my $default_result = 0;
   my $default_value;
   my $start_place;

   if ((@parts[0] ne "z") && (@parts[0] ne "y"))
   {
      if (@parts[0] eq "f")   # checking to see if all phasetypes are stochastic (0)
      {
         $default_value = $DEFAULT_PHASE;
         $start_place = 2;
      }
      elsif (@parts[0] eq "c") # checking to see if all COV are exponential (1)
      {
         $default_value = $DEFAULT_COV;   
         $start_place = 2;
      }
      elsif (@parts[0] eq "i")  # checking to see if all Fan_In is 0
      {
         $default_value = $DEFAULT_FANIN;
         $start_place = 3;
      }
      elsif (@parts[0] eq "o")  # checking to see if all Fan_Out is 0
      {
         $default_value = $DEFAULT_FANOUT;
         $start_place = 3;
      }
      elsif (@parts[0] eq "Z") # checking to see if Think_Time is 0
      {
         $default_value = $DEFAULT_THINKTIME;
         $start_place = 2;
      }
     else
     {
        die "INTERNAL ERROR - spreadsheet parser has reached an unknown state in function all_default_values.\n";
     }

# we start looking through the fields to see if certain values are all the same

      for ($x=$start_place;$x<$num_parts;$x++)
      {
         if (@parts[$x] != $default_value)
         {
            last;
         }
      }

      if ($x == $num_parts)
      {
         $default_result = 1;
      }
   }
   $default_result;
}

# We need to return a TRUE (1), otherwise Perl complains.
1;
